<template>
  <div id="app" >
    <transition :name="transitionName">
      <keep-alive>
        <router-view v-if="$route.meta.keepAlive"/>
      </keep-alive>
    </transition>
    <transition :name="transitionName">
      <router-view v-if="!$route.meta.keepAlive"/>
    </transition>
  </div>
</template>

<script>
export default {
  data () {
    return {
      pathList: [],
      transitionName: 'slide-left',
    }
  },
  watch: { // 监听路由变化
    $route (to, from) {
      if (this.pathList.includes(to.path)) {
        const index = (this.pathList.findIndex(() => {
          return from.path
        }))
        this.pathList.splice(index, 1)
        this.$router.isBack = true
      } else {
        this.pathList.push(to.path)
        this.$router.isBack = false
      }
      if (to.path === '/home') {
        this.$router.isBack = true
        this.pathList = []
      }
      let isBack = this.$router.isBack
      if (isBack) {
        this.transitionName = 'router-slide-right'
      } else {
        this.transitionName = 'router-slide-left'
      }
      this.$router.isBack = false
    },
  },
  mounted () {
    this.getAccessToken()
  },
  methods: {
    // 右滑返回上一页
    onSwipeRight () {
      if (this.$route.name === 'Home') return
      this.$router.go(-1)
    },
    getAccessToken () {
      let vm = this
      let url = process.env.loginPath + 'appadmin'
      let param = {}
      vm.hlsHttp.post(url, param).then(function (res) {
        window.localStorage.setItem('access_token', res.access_token)
      })
    },
  },
}
</script>

<style lang="less">
  html, body, #app {
    height: 100%;
    width: 100%;
    overflow-x: hidden;
    //overflow: auto;
    //-webkit-overflow-scrolling: touch;
    //overflow-scrolling: touch;
  }
</style>
